﻿<%@ WebHandler Language="C#" Class="GetFile" %>

using System;
using System.Web;

public class GetFile : IHttpHandler
{
    public void ProcessRequest(HttpContext context)
    {
        context.Response.Clear() ;
        context.Response.ClearHeaders() ;
        context.Response.ClearContent() ;

        string filename = context.Request.QueryString["file"].ToString().Trim();
        string path = context.Server.MapPath("~/Downloads/" + filename);
        System.IO.FileInfo file = new System.IO.FileInfo(path);
        if (file.Exists)
        {
            if (file.Name.ToString().Equals("mps.zip", StringComparison.InvariantCultureIgnoreCase))
            {
                if (context.User.Identity.IsAuthenticated)
                {
                    context.Response.AddHeader("content-disposition", "attachment; filename=" + file.Name);
                    context.Response.AddHeader("content-Length", file.Length.ToString());
                    context.Response.ContentType = ReturnExtension(file.Extension.ToLower());
                    context.Response.TransmitFile(path);
                    context.Response.End();
                }
                else
                {
                    context.Response.Redirect(System.Web.Security.FormsAuthentication.LoginUrl + "?ReturnUrl=Source.aspx" );
                }
            }
            else
            {
                context.Response.AddHeader("content-disposition", "attachment; filename=" + file.Name);
                context.Response.AddHeader("content-Length", file.Length.ToString());
                context.Response.ContentType = ReturnExtension(file.Extension.ToLower());
                context.Response.TransmitFile(path);
                context.Response.End();
            }
        }
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

    private string ReturnExtension(string fileExtension)
    {
        switch (fileExtension)
        {
            case ".htm":
            case ".html":
            case ".log":
                return "text/HTML";
            case ".txt":
                return "text/plain";
            case ".doc":
                return "application/ms-word";
            case ".tiff":
            case ".tif":
                return "image/tiff";
            case ".asf":
                return "video/x-ms-asf";
            case ".avi":
                return "video/avi";
            case ".zip":
                return "application/zip";
            case ".xls":
            case ".csv":
                return "application/vnd.ms-excel";
            case ".gif":
                return "image/gif";
            case ".jpg":
            case "jpeg":
                return "image/jpeg";
            case ".bmp":
                return "image/bmp";
            case ".wav":
                return "audio/wav";
            case ".mp3":
                return "audio/mpeg3";
            case ".mpg":
            case "mpeg":
                return "video/mpeg";
            case ".rtf":
                return "application/rtf";
            case ".asp":
                return "text/asp";
            case ".pdf":
                return "application/pdf";
            case ".fdf":
                return "application/vnd.fdf";
            case ".ppt":
                return "application/mspowerpoint";
            case ".dwg":
                return "image/vnd.dwg";
            case ".msg":
                return "application/msoutlook";
            case ".xml":
            case ".sdxl":
                return "application/xml";
            case ".xdp":
                return "application/vnd.adobe.xdp+xml";
            default:
                return "application/octet-stream";
        }
    }
}

